install 31 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839840841842843844845846847848849850851852853854855856857858859860861862863864865866867868869870871872873874875876877878879880881882883884885886887888889890891892893894895896897898899900901902903904905906907908909910911912913914915916917918919920921922923924925926927928929930931932933934935936937938939940941942943944945946947948949950951952953954955956957958959960961962963964965966967968969970971972973974975976977978979980981982983984985986987988989990991992993994995996997
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. comprobarError() {
  11. # comprobarError exitNum codeNum extraInfo
  12. # 1xx: Servidor Web
  13. # 2xx: Base de Datos
  14. # 3xx: PHP
  15. # 4xx: SSL/TLS
  16. # 5xx: MediaWiki
  17. # 6xx: Moodle
  18. # 7xx: Actualizaciones automáticas
  19. # 8xx: Dependencias
  20. # 9xx: Servicios
  21. type="ERROR"
  22. exitNum=$1
  23. codeNum=$2
  24. extraInfo=$3
  25. case $codeNum in
  26. 1)
  27. error="$type $codeNum:\tInstalación interrumpida por el usuario.\n"
  28. ;;
  29. 2)
  30. error="$type $codeNum:\tError interno (selección express).\n"
  31. ;;
  32. 3)
  33. error="$type $codeNum:\tError interno (selección avanzada).\n"
  34. ;;
  35. 100)
  36. error="$type $codeNum:\tError interno (selección del servidor web).\n"
  37. ;;
  38. 101)
  39. error="\n$type $codeNum:\tError al instalar Apache2.\nDetalles:\n$extraInfo\n"
  40. ;;
  41. 102)
  42. error="\n$type $codeNum:\tError al instalar Nginx.\nDetalles:\n$extraInfo\n"
  43. ;;
  44. 103)
  45. error="\n$type $codeNum:\tError al nstalar repositorio 'epel-release'.\nDetalles:\n$extraInfo\n"
  46. ;;
  47. 104)
  48. error="\n$type $codeNum:\tError interno (instalación Apache2).\n"
  49. ;;
  50. 105)
  51. error="\n$type $codeNum:\tError interno (instalación Nginx).\n"
  52. ;;
  53. 106)
  54. type="WARNING"
  55. error="\n$type $codeNum:\tImposible instalar 'info.php'.\n"
  56. ;;
  57. 107)
  58. error="\n$type $codeNum:\tError al configurar Nginx.\n"
  59. ;;
  60. 200)
  61. error="$type $codeNum:\tError interno (selección de base de datos).\n"
  62. ;;
  63. 201)
  64. error="\n$type $codeNum:\tError al instalar MySQL.\nDetalles:\n$extraInfo\n"
  65. ;;
  66. 202)
  67. error="\n$type $codeNum:\tError al instalar MariaDB.\nDetalles:\n$extraInfo\n"
  68. ;;
  69. 203)
  70. error="\n$type $codeNum:\tError interno (instalación MySQL).\n"
  71. ;;
  72. 204)
  73. error="\n$type $codeNum:\tError interno (instalación MariaDB).\n"
  74. ;;
  75. 205)
  76. error="\n$type $codeNum:\t$DIST no incluye MySQL en sus repositorios.\n"
  77. ;;
  78. 206)
  79. type="WARNING"
  80. error="$type $codeNum:\tUsuario 'root' ya dispone de contraseña.\n"
  81. ;;
  82. 207)
  83. error="$type $codeNum:\tImposible cambiar la contraseña de 'root'.\n"
  84. ;;
  85. 208)
  86. error="$type $codeNum:\tImposible desactivar acceso 'root' desde el exterior.\n"
  87. ;;
  88. 209)
  89. error="$type $codeNum:\tImposible eliminar usuarios anónimos.\n"
  90. ;;
  91. 210)
  92. type="WARNING"
  93. error="$type $codeNum:\tImposible eliminar bases de datos de pruebas.\n"
  94. ;;
  95. 211)
  96. type="WARNING"
  97. error="$type $codeNum:\tImposible eliminar los permisos de las bases de datos de pruebas.\n"
  98. ;;
  99. 212)
  100. error="$type $codeNum:\tImposible recargar base de datos.\n"
  101. ;;
  102. 300)
  103. error="\n$type $codeNum:\tError interno (instalación PHP-7.2).\n"
  104. ;;
  105. 301)
  106. error="\n$type $codeNum:\tError interno (Web Server no seleccionado).\n"
  107. ;;
  108. 302)
  109. error="\n$type $codeNum:\tError al instalar PHP-7.2.\nDetalles:\n$extraInfo\n"
  110. ;;
  111. 303)
  112. error="\n$type $codeNum:\tError al instalar Repositorio Remi.\nDetalles:\n$extraInfo\n"
  113. ;;
  114. 304)
  115. error="\n$type $codeNum:\tSistema Operativo no compatible con PHP-7.2 ($OS $DIST $REV).\n"
  116. ;;
  117. 305)
  118. error="\n$type $codeNum:\tImposible configurar PHP-7.2.\n"
  119. ;;
  120. 800)
  121. error="$type $codeNum:\tEs necesario ser root ('sudo $0').\n"
  122. ;;
  123. 801)
  124. error="$type $codeNum:\t'whiptail' no instalado.\n"
  125. ;;
  126. 802)
  127. error="$type $codeNum:\t'hostnamectl' no instalado.\n"
  128. ;;
  129. 803)
  130. error="$type $codeNum:\t'apt-get' no instalado.\n"
  131. ;;
  132. 804)
  133. error="$type $codeNum:\t'yum' no instalado.\n"
  134. ;;
  135. 805)
  136. error="\n$type $codeNum:\tImposible actualizar repositorio\nDetalles:\n$extraInfo.\n"
  137. ;;
  138. 806)
  139. error="$type $codeNum:\t'ufw' no instalado.\n"
  140. ;;
  141. 807)
  142. error="$type $codeNum:\t'firewall-cmd' no instalado.\n"
  143. ;;
  144. 808)
  145. error="$type $codeNum:\t'tput' no instalado.\n"
  146. ;;
  147. 809)
  148. error="$type $codeNum:\t'sed' no instalado.\n"
  149. ;;
  150. 900)
  151. error="$type $codeNum:\tError interno (habilitar servicio).\n"
  152. ;;
  153. 901)
  154. error="$type $codeNum:\tImposible encender servicio '$extraInfo'.\n"
  155. ;;
  156. 902)
  157. error="$type $codeNum:\tImposible habilitar servicio '$extraInfo' durante el arranque.\n"
  158. ;;
  159. 903)
  160. error="$type $codeNum:\tError interno (deshabilitar servicio).\n"
  161. ;;
  162. 904)
  163. error="$type $codeNum:\tImposible parar servicio '$extraInfo'.\n"
  164. ;;
  165. 905)
  166. error="$type $codeNum:\tImposible deshabilitar servicio '$extraInfo' durante el arranque.\n"
  167. ;;
  168. *)
  169. error="ERROR 13:\tError interno (comprobación de errores)\n"
  170. exitNum=1
  171. codeNum=13
  172. ;;
  173. esac
  174. if [ $exitNum -ne 0 ];then
  175. echo -en "$error" | tee -a $logFile
  176. if [ $type = "ERROR" ];then
  177. exit $codeNum
  178. fi
  179. fi
  180. unset error exitNum codeNum type
  181. }
  182. OSInfo() {
  183. echo -en "Detectando SO..." >> $logFile
  184. OS=$(uname -s)
  185. if [ $OS = "Linux" ]; then
  186. OS="GNU/Linux"
  187. if [ -f /etc/os-release ]; then
  188. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  189. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  190. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  191. VERSION=$(grep ^VERSION_ID= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  192. for i in $ID_LIKE; do
  193. #echo -en "$i\n"
  194. case $i in
  195. debian|ubuntu)
  196. debianOS=true
  197. break
  198. ;;
  199. rhel|fedora)
  200. rhelOS=true
  201. break
  202. ;;
  203. *)
  204. debianOS=false
  205. rhelOS=false
  206. ;;
  207. esac
  208. done
  209. elif [ -f /etc/debian-version ]; then
  210. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  211. DIST="Debian"
  212. REV=""
  213. ID_LIKE="debian"
  214. VERSION=""
  215. debianOS=true
  216. elif [ -f /etc/redhat-release ]; then
  217. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  218. DIST="Red-Hat"
  219. REV=""
  220. ID_LIKE="rhel"
  221. VERSION=""
  222. rhelOS=true
  223. else
  224. # Other Linux (No Soportado)
  225. DIST=""
  226. REV=""
  227. ID_LIKE=""
  228. VERSION=""
  229. fi
  230. else
  231. # UNIX, OS X, ... (No Soportado)
  232. DIST=$OS
  233. REV=""
  234. ID_LIKE=""
  235. VERSION=""
  236. fi
  237. echo -en " $OS $DIST $REV\n" >> $logFile
  238. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  239. echo -en "$HDInfo\n" >> $logFile
  240. }
  241. comprobarRoot() {
  242. comprobarError $(id -u) 800
  243. }
  244. comprobarDependencias() {
  245. # Comprobamos whiptail
  246. which whiptail > /dev/null 2>&1
  247. comprobarError $? 801
  248. # Comprobamos hostnamectl
  249. which hostnamectl > /dev/null 2>&1
  250. comprobarError $? 802
  251. # Comprobamos tput
  252. which tput > /dev/null 2>&1
  253. comprobarError $? 808
  254. # Comprobamso sed
  255. which sed > /dev/null 2>&1
  256. comprobarError $? 809
  257. if [ $debianOS = true ];then
  258. # Comprobamos apt-get
  259. which apt-get > /dev/null 2>&1
  260. comprobarError $? 803
  261. # Actualizamos base de datos del repositorio
  262. echo -en "Actualizando repositorio APT..." | tee -a $logFile
  263. result=$(apt-get -q -y update)
  264. comprobarError $? 805 $result
  265. echo -en " OK.\n" | tee -a $logFile
  266. # Comprobamos Firewall (ufw)
  267. which ufw > /dev/null 2>&1
  268. comprobarError $? 806
  269. fi
  270. if [ $rhelOS = true ]; then
  271. # Comprobamos yum
  272. which yum > /dev/null 2>&1
  273. comprobarError $? 804
  274. # Actualizamos base de datos del repositorio
  275. echo -en "Actualizando repositorio YUM..." | tee -a $logFile
  276. result=$(yum -y makecache 2>&1)
  277. comprobarError $? 805 $result
  278. echo -en " OK.\n" | tee -a $logFile
  279. # Comprobamos Firewall (firewall-cmd)
  280. which firewall-cmd > /dev/null 2>&1
  281. comprobarError $? 807
  282. fi
  283. }
  284. inicializarVariables() {
  285. debianOS=false
  286. rhelOS=false
  287. apacheOn=false
  288. nginxOn=false
  289. mySQLOn=false
  290. mariaDBOn=false
  291. phpOn=false
  292. mediaWikiOn=false
  293. moodleOn=false
  294. infoPHPOn=false
  295. actualizacionesOn=false
  296. progreso=0
  297. progresoTotal=0
  298. logFile="./."$(basename $0)".log"
  299. maxUpload="100M"
  300. }
  301. instalacionExpress() {
  302. apacheOn=true
  303. mariaDBOn=true
  304. phpOn=true
  305. mediaWikiOn=true
  306. moodleOn=true
  307. actualizacionesOn=true
  308. progresoTotal=15
  309. # Preguntas mínimas
  310. establecerFQDN
  311. leerSQLPasswd
  312. }
  313. mostrarBienvenida() {
  314. ANCHO=$(tput cols)
  315. ALTO=$(tput lines)
  316. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  317. whiptail --title "ERROR S.O. NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Salir"
  318. exit 1
  319. fi
  320. whiptail --title "INSTALACION MEDIAWIKI" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Continuar" --no-button "Salir"
  321. comprobarError $? 1
  322. }
  323. mostrarExpress() {
  324. express=$(whiptail --title "INSTALACION EXPRESS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nLa instalación express instala Apache2, MariaDB, PHP-7, Let's Encrypt, MediaWiki, Moodle y actualizaciones automáticas.\nSeleccione el tipo de instalación que desee:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  325. "Express" "Instalación rápida" ON \
  326. "Avanzada" "Permite escoger todas las opciones disponibles" OFF \
  327. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  328. comprobarError $? 1
  329. case $express in
  330. Express)
  331. instalacionExpress
  332. # DECIDIR QUÉ OPCIONES SON LAS MÍNIMAS
  333. ;;
  334. Avanzada)
  335. mostrarAvanzada
  336. ;;
  337. *)
  338. comprobarError 1 2
  339. ;;
  340. esac
  341. }
  342. mostrarAvanzada() {
  343. webServer=$(whiptail --title "INSTALACION AVANZADA" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el tipo de Servidor Web que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  344. "LAMP" "GNU/Linux + Apache + MySQL/MariaDB + PHP-7" ON \
  345. "LEMP" "GNU/Linux + Nginx + MySQL/MariaDB + PHP-7" OFF \
  346. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  347. comprobarError $? 1
  348. for i in $webServer; do
  349. case $i in
  350. LAMP)
  351. apacheOn=true
  352. ;;
  353. LEMP)
  354. nginxOn=true
  355. ;;
  356. *)
  357. comprobarError 1 100
  358. ;;
  359. esac
  360. done
  361. # Opciones comunes
  362. establecerFQDN
  363. mostrarDatabase
  364. phpOn=true
  365. establecerMaxUpload
  366. progresoTotal=$((progresoTotal + 6))
  367. mostrarComponentes
  368. }
  369. mostrarComponentes() {
  370. componentes=$(whiptail --title "INSTALACION AVANZADA" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 5 \
  371. "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
  372. "MediaWiki" "Instalar wiki con MediaWiki" ON \
  373. "Moodle" "Instalar campus virtual con Moodle" ON \
  374. "InfoPHP" "Instalar info.php (sólo para pruebas)" OFF \
  375. "Actualizaciones" "Programar actualizaciones automáticas" ON \
  376. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  377. comprobarError $? 1
  378. # Mejora: autodetección de componentes ya instalados
  379. for i in $componentes; do
  380. case $i in
  381. \"SSL/TLS\")
  382. # 2 Opciones: Let's Encrypt o Autofirmado
  383. progresoTotal=$((progresoTotal + 2))
  384. ;;
  385. \"MediaWiki\")
  386. mediaWikiOn=true
  387. progresoTotal=$((progresoTotal + 2))
  388. ;;
  389. \"Moodle\")
  390. moodleOn=true
  391. progresoTotal=$((progresoTotal + 2))
  392. ;;
  393. \"InfoPHP\")
  394. infoPHPOn=true
  395. progresoTotal=$((progresoTotal + 2))
  396. ;;
  397. \"Actualizaciones\")
  398. actualizacionesOn=true
  399. progresoTotal=$((progresoTotal + 1))
  400. ;;
  401. *)
  402. comprobarError 1 3
  403. ;;
  404. esac
  405. done
  406. progresoTotal=$((progresoTotal + 2))
  407. }
  408. establecerFQDN() {
  409. while [ -z $hostname ]; do
  410. hostname=$(whiptail --title "FQDN" --inputbox "El nombre de dominio principal (FQDN) de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Cambiar" --cancel-button "No Cambiar" 3>&1 1>&2 2>&3)
  411. if [ $? -eq 0 ] && [ ! -z $hostname ]; then
  412. hostnamectl set-hostname $hostname
  413. else
  414. hostname=$(hostname)
  415. fi
  416. done
  417. echo -en "Hostname: $hostname\n" >> $logFile
  418. }
  419. instalarApache() {
  420. if [ $debianOS = true ];then
  421. result=$(apt-get -q -y install apache2 2>&1)
  422. comprobarError $? 101 $result
  423. elif [ $rhelOS = true ]; then
  424. result=$(yum -y install httpd 2>&1)
  425. comprobarError $? 101 $result
  426. else
  427. comprobarError 1 104
  428. fi
  429. }
  430. instalarNginx() {
  431. if [ $debianOS = true ];then
  432. result=$(apt-get -q -y install nginx 2>&1)
  433. comprobarError $? 102 $result
  434. elif [ $rhelOS = true ]; then
  435. # Hay que instalar primero otro repositorio
  436. result=$(yum -y install epel-release)
  437. comprobarError $? 103 $result
  438. result=$(yum -y install nginx 2>&1)
  439. comprobarError $? 102 $result
  440. else
  441. comprobarError 1 105
  442. fi
  443. }
  444. configurarNginx() {
  445. # Configuramos Nginx
  446. rm -Rf /etc/nginx/* 2>/dev/null
  447. comprobarError $? 107
  448. if [ $debianOS = true ];then
  449. nginxConfFile="./etc/nginx-debian/*"
  450. elif [ $rhelOS = true ];then
  451. nginxConfFile="./etc/nginx-rhel/*"
  452. fi
  453. if [ ! -f $nginxConfFile ];then
  454. comprobarError 1 107
  455. fi
  456. cp -R $nginxConfFile /etc/nginx/ 2>/dev/null
  457. comprobarError $? 107
  458. unset nginxConfFile
  459. }
  460. mostrarDatabase() {
  461. if [ $debianOS = true ]; then
  462. database=$(whiptail --title "BASE DE DATOS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  463. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" ON \
  464. "MySQL" "Instalar la base de datos MySQL (no para uso comercial)" OFF \
  465. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  466. comprobarError $? 1
  467. case $database in
  468. MariaDB)
  469. mariaDBOn=true
  470. ;;
  471. MySQL)
  472. mySQLOn=true
  473. ;;
  474. *)
  475. comprobarError 1 200
  476. ;;
  477. esac
  478. elif [ $rhelOS = true ]; then
  479. whiptail --title "BASE DE DATOS" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Continuar" --no-button "Salir"
  480. comprobarError $? 1
  481. mariaDBOn=true
  482. else
  483. comprobarError 1 200
  484. fi
  485. # Otras opciones (contraseña)
  486. leerSQLPasswd
  487. }
  488. leerSQLPasswd() {
  489. control=false
  490. error=""
  491. # Leemos la contreseña (stdin) y confirmamos
  492. while [ $control = false ]; do
  493. sqlPasswd=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "$error""Introduzca la contraseña para el usuario 'root' de la base de datos:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  494. comprobarError $? 1
  495. sqlPasswd2=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "Confirme la contraseña:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  496. comprobarError $? 1
  497. #echo -en "SQL Password 1: $sqlPasswd\n"
  498. #echo -en "SQL Password 2: $sqlPasswd2\n"
  499. if [ -z $sqlPasswd ] || [ -z $sqlPasswd2 ]; then
  500. error="ERROR: LA CONTRASEÑA NO PUEDE ESTAR VACIA.\n"
  501. elif [ $sqlPasswd != $sqlPasswd2 ];then
  502. error="ERROR: LAS CONTRASEÑAS NO COINCIDEN.\n"
  503. else
  504. control=true
  505. fi
  506. done
  507. #echo -en "SQL Password: $sqlPasswd\n"
  508. unset control error sqlPasswd2
  509. }
  510. establecerSQLPasswd() {
  511. # Establecemos SQL root passwd y securizamos BD (mysql_secure_installation)
  512. # Comprobamos si ya tiene una contraseña asignada
  513. mysql -e "FLUSH PRIVILEGES" >> $logFile 2>&1
  514. if [ $? -eq 0 ];then
  515. # Establecemos contraseña del usuario root
  516. mysql -e "UPDATE mysql.user SET Password = PASSWORD('$sqlPasswd') WHERE User = 'root'" >> $logFile 2>&1
  517. comprobarError $? 207
  518. # Desactivamos acceso root desde el exterior (solo localhost)
  519. mysql -e "DELETE FROM mysql.user WHERE User='root' AND Host NOT IN ('localhost', '127.0.0.1', '::1')" >> $logFile 2>&1
  520. comprobarError $? 208
  521. # Eliminamos todos los usuarios anónimos
  522. mysql -e "DELETE FROM mysql.user WHERE User=''" >> $logFile 2>&1
  523. comprobarError $? 209
  524. # Eliminamos bases de datos 'test'
  525. mysql -e "DROP DATABASE IF EXISTS test" >> $logFile 2>&1
  526. comprobarError $? 210
  527. # Eliminamos privilegios de la base de datos 'test'
  528. mysql -e "DELETE FROM mysql.db WHERE Db='test' OR Db='test\\_%'" >> $logFile 2>&1
  529. comprobarError $? 211
  530. # Aplicamos los cambios
  531. mysql -e "FLUSH PRIVILEGES" >> $logFile 2>&1
  532. comprobarError $? 212
  533. else
  534. comprobarError 1 206
  535. fi
  536. }
  537. instalarMySQL() {
  538. if [ $debianOS = true ];then
  539. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  540. comprobarError $? 201 $result
  541. elif [ $rhelOS = true ];then
  542. # MySQL no disponible en RHEL. 2 opciones:
  543. # 1) Instalar un repositorio adicional
  544. # 2) No instalar MySQL en distribuciones RHEL
  545. comprobarError 1 205
  546. else
  547. comprobarError 1 203
  548. fi
  549. }
  550. instalarMariaDB() {
  551. if [ $debianOS = true ];then
  552. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  553. comprobarError $? 202 $result
  554. elif [ $rhelOS = true ];then
  555. result=$(yum -y install mariadb-server mariadb 2>&1)
  556. comprobarError $? 202 $result
  557. else
  558. comprobarError 1 204
  559. fi
  560. }
  561. instalarPHP() {
  562. # Instalamos PHP-7 de forma diferente si es junto a Apache o con Nginx
  563. if [ $debianOS = true ];then
  564. if [ $apacheOn = true ]; then
  565. result=$(apt-get -q -y install php libapache2-mod-php php-mysql php-intl php-mbstring openssl 2>&1)
  566. comprobarError $? 302 $result
  567. elif [ $nginxOn = true ];then
  568. result=$(apt-get -q -y install php-fpm libapache2-mod-php php-mysql php-intl php-mbstring openssl 2>&1)
  569. comprobarError $? 302 $result
  570. else
  571. comprobarError 1 301
  572. fi
  573. elif [ $rhelOS = true ];then
  574. # Necesitamos un repositorio adicional para PHP-7 (EPEL-RELEASE)
  575. result=$(yum -y install epel-release yum-utils)
  576. comprobarError $? 103 $result
  577. # Necesitamos un repositorio adicional para PHP-7 (REMI-RELEASE)
  578. if [ $VERSION = "7" ];then
  579. result=$(yum -y install http://remi.mirrors.cu.be/enterprise/remi-release-7.rpm 2>&1)
  580. comprobarError $? 303 $result
  581. elif [ $VERSION = "6" ];then
  582. result=$(yum -y install http://remi.mirrors.cu.be/enterprise/remi-release-6.rpm 2>&1)
  583. comprobarError $? 303 $result
  584. elif [ $VERSION = "28" ];then
  585. result=$(yum -y install http://remi.mirrors.cu.be/fedora/remi-release-28.rpm 2>&1)
  586. comprobarError $? 303 $result
  587. elif [ $VERSION = "27" ];then
  588. result=$(yum -y install http://remi.mirrors.cu.be/fedora/remi-release-27.rpm 2>&1)
  589. comprobarError $? 303 $result
  590. else
  591. comprobarError 1 304
  592. fi
  593. # Activamos repositorio remi-php72
  594. result=$(yum-config-manager --enable remi-php72 2>&1)
  595. comprobarError $? 303 $result
  596. # Instalamos PHP-7.2
  597. if [ $apacheOn = true ];then
  598. result=$(yum -y install php php-mysql php-intl php-mbstring php-mcrypt openssl 2>&1)
  599. comprobarError $? 302 $result
  600. elif [ $nginxOn = true ];then
  601. result=$(yum -y install php php-fpm php-mysql php-intl php-mbstring php-mcrypt openssl 2>&1)
  602. comprobarError $? 302 $result
  603. else
  604. comprobarError 1 301
  605. fi
  606. else
  607. comprobarError 1 300
  608. fi
  609. }
  610. configurarPHP() {
  611. # Configura PHP para segurizarlo y establecer máximo de subida.
  612. if [ $debianOS = true ];then
  613. phpConfFile="./etc/php/php.ini.debian"
  614. phpDest="/etc/php/7.2/cli/php.ini"
  615. elif [ $rhelOS = true ];then
  616. phpConfFile="./etc/php/php.ini.rhel"
  617. phpDest="/etc/php.ini"
  618. fi
  619. if [ ! -f $phpConfFile ];then
  620. comprobarError 1 305
  621. fi
  622. # Copiamos configuración
  623. cp $phpConfFile $phpDest 2>/dev/null
  624. comprobarError $? 305
  625. # Configuramos cgi.fix_pathinfo
  626. sed -i '/cgi.fix_pathinfo=/c\cgi.fix_pathinfo=0' $phpDest
  627. comprobarError $? 305
  628. # Configuramos post_max_size
  629. sed -i '/post_max_size =/c\post_max_size = '$maxUpload $phpDest
  630. comprobarError $? 305
  631. # Configuramos upload_max_filesize
  632. sed -i '/upload_max_filesize =/c\upload_max_filesize = '$maxUpload $phpDest
  633. comprobarError $? 305
  634. # Configurar php-fpm (sólo en RHEL con Nginx)
  635. if [ $rhelOS = true ] && [ $nginxOn = true ];then
  636. phpConfFile="./etc/php/php-fpm.d/www.conf"
  637. phpDest="/etc/php-fpm.d/www.conf"
  638. if [ ! -f $phpConfFile ];then
  639. comprobarError $? 305
  640. fi
  641. cp $phpConfFile $phpDest 2>/dev/null
  642. comprobarError $? 305
  643. fi
  644. unset phpConfFile phpDest
  645. }
  646. establecerMaxUpload() {
  647. control=false
  648. error=""
  649. while [ $control = false ];do
  650. maxUpload2=$(whiptail --title "PHP MAX UPLOAD" --inputbox "$error""Introduzca el tamaño máximo permitido de los ficheros subidos al servidor:\n(<K:Kilobyte> <M:Megabyte> <G:Gigabyte>)" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) $maxUpload --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  651. comprobarError $? 1
  652. if [ -z $maxUpload2 ];then
  653. error="ERROR: NO PUEDES DEJAR ESTE PARÁMETRO VACIO.\n"
  654. else
  655. control=true
  656. fi
  657. done
  658. maxUpload=$maxUpload2
  659. unset control maxUpload2
  660. }
  661. instalarPHPInfo() {
  662. infoFile="./var/www/info.php"
  663. if [ ! -f $infoFile ];then
  664. comprobarError 1 106
  665. fi
  666. cp $infoFile /var/www/html/ 2>/dev/null
  667. comprobarError $? 106
  668. unset infoFile
  669. }
  670. habilitarServicio() {
  671. # Arrancamos y habilitamos el servicio (con SystemD, Upstart o SystemV)
  672. # Intentamos con systemctl (SystemD)
  673. echo -en "Habilitando servicio $1" | tee -a $logFile
  674. if [ $# -le 0 ];then
  675. comprobarError 1 900
  676. fi
  677. which systemctl > /dev/null 2>&1
  678. if [ $? -eq 0 ]; then
  679. echo -en " (SystemD)..." | tee -a $logFile
  680. systemctl start $1 > /dev/null 2>&1
  681. comprobarError $? 901 $1
  682. systemctl enable $1 > /dev/null 2>&1
  683. comprobarError $? 902 $1
  684. else
  685. # Intentamos con service (Upstart)
  686. which service > /dev/null 2>&1
  687. if [ $? -eq 0 ]; then
  688. echo -en " (Upstart)..." | tee -a $logFile
  689. service $1 start > /dev/null 2>&1
  690. comprobarError $? 901 $1
  691. else
  692. # Intentamos con init.d (SystemV)
  693. echo -en " (SystemV)..." | tee -a $logFile
  694. /etc/init.d/$1 start > /dev/null 2>&1
  695. comprobarError $? 901 $1
  696. fi
  697. # Intentamos habilitar en el arranque (Upstart)
  698. which update-rc.d > /dev/null 2>&1
  699. if [ $? -eq 0 ];then
  700. update-rc.d $1 enable
  701. comprobarError $? 902 $1
  702. else
  703. # Intentamos habilitar en el arranque (SystemV)
  704. which chkconfig > /dev/null 2>&1
  705. if [ $? -eq 0 ];then
  706. chkconfig $1 on
  707. comprobarError $? 902 $1
  708. else
  709. # ¿Qué mas opciones nos quedan?
  710. comprobarError 1 902 $1
  711. fi
  712. fi
  713. fi
  714. # Mejora: comprobar si el servicio está funcionando
  715. echo -en " OK.\n" | tee -a $logFile
  716. }
  717. deshabilitarServicio() {
  718. # Paramos y deshabilitamos el servicio (con SystemD, Upstart o SystemV)
  719. # Intentamos con systemctl (SystemD)
  720. echo -en "Deshabilitando servicio $1" | tee -a $logFile
  721. if [ $# -le 0 ];then
  722. comprobarError 1 903
  723. fi
  724. which systemctl > /dev/null 2>&1
  725. if [ $? -eq 0 ]; then
  726. echo -en " (SystemD)..." | tee -a $logFile
  727. systemctl stop $1 > /dev/null 2>&1
  728. comprobarError $? 904 $1
  729. systemctl disable $1 > /dev/null 2>&1
  730. comprobarError $? 905 $1
  731. else
  732. # Intentamos con service (Upstart)
  733. which service > /dev/null 2>&1
  734. if [ $? -eq 0 ]; then
  735. echo -en " (Upstart)..." | tee -a $logFile
  736. service $1 stop > /dev/null 2>&1
  737. comprobarError $? 904 $1
  738. else
  739. # Intentamos con init.d (SystemV)
  740. echo -en " (SystemV)..." | tee -a $logFile
  741. /etc/init.d/$1 stop > /dev/null 2>&1
  742. comprobarError $? 904 $1
  743. fi
  744. # Intentamos habilitar en el arranque (Upstart)
  745. which update-rc.d > /dev/null 2>&1
  746. if [ $? -eq 0 ];then
  747. update-rc.d $1 disable
  748. comprobarError $? 905 $1
  749. else
  750. # Intentamos habilitar en el arranque (SystemV)
  751. which chkconfig > /dev/null 2>&1
  752. if [ $? -eq 0 ];then
  753. chkconfig $1 off
  754. comprobarError $? 905 $1
  755. else
  756. # ¿Qué mas opciones nos quedan?
  757. comprobarError 1 905 $1
  758. fi
  759. fi
  760. fi
  761. # Mejora: comprobar si el servicio está funcionando
  762. echo -en " OK.\n" | tee -a $logFile
  763. }
  764. # Comprobación del sistema e inicialización
  765. inicializarVariables
  766. comprobarRoot
  767. OSInfo
  768. comprobarDependencias
  769. # Bienvenida
  770. mostrarBienvenida
  771. # Selección de componentes (express vs avanzada)
  772. mostrarExpress
  773. # Pre-configuración
  774. # Habilitar cortafuegos -> PROBLEMA: se corta la conexión ssh
  775. # Instalación
  776. # FALTA: whiptail --gauge -> Más bonito
  777. # Servidor Web
  778. if [ $apacheOn = true ]; then
  779. echo -en "Instalando Web Server Apache..." | tee -a $logFile
  780. # {
  781. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  782. instalarApache
  783. progreso=$((progreso + 1))
  784. # } > >(whiptail --gauge "Instalando Web Server Apache..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  785. echo -en " OK.\n" | tee -a $logFile
  786. elif [ $nginxOn = true ]; then
  787. echo -en "Instalando Web Server Nginx..." | tee -a $logFile
  788. # {
  789. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  790. instalarNginx
  791. progreso=$((progreso + 1))
  792. # } > >(whiptail --gauge "Instalando Web Server Nginx..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  793. echo -en " OK.\n" | tee -a $logFile
  794. fi
  795. # Base de Datos
  796. if [ $mySQLOn = true ]; then
  797. echo -en "Instalando Base de Datos MySQL..." | tee -a $logFile
  798. # {
  799. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  800. instalarMySQL
  801. progreso=$((progreso + 1))
  802. # } > >(whiptail --gauge "Instalando Base de Datos MySQL..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  803. echo -en " OK.\n" | tee -a $logFile
  804. elif [ $mariaDBOn = true ]; then
  805. echo -en "Instalando Base de Datos MariaDB..." | tee -a $logFile
  806. # {
  807. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  808. instalarMariaDB
  809. progreso=$((progreso + 1))
  810. # } > >(whiptail --gauge "Instalando Base de Datos MariaDB..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  811. echo -en " OK.\n" | tee -a $logFile
  812. fi
  813. # PHP
  814. if [ $phpOn = true ]; then
  815. echo -en "Instalando PHP-7..." | tee -a $logFile
  816. # {
  817. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  818. instalarPHP
  819. progreso=$((progreso + 1))
  820. # } > >(whiptail --gauge "Instalando PHP-7..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  821. echo -en " OK.\n" | tee -a $logFile
  822. fi
  823. # SSL/TLS
  824. # Falta por implementar
  825. # {
  826. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  827. sleep 2
  828. progreso=$((progreso + 1))
  829. # } > >(whiptail --gauge "Instalando SSL/TLS..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  830. # MediaWiki
  831. if [ $mediaWikiOn = true ]; then
  832. echo -en "Instalando MediaWiki..." | tee -a $logFile
  833. # {
  834. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  835. sleep 2
  836. progreso=$((progreso + 1))
  837. # } > >(whiptail --gauge "Instalando MediaWiki..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  838. echo -en " OK.\n" | tee -a $logFile
  839. fi
  840. # Moodle
  841. if [ $moodleOn = true ]; then
  842. echo -en "Instalando Moodle..." | tee -a $logFile
  843. # {
  844. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  845. sleep 2
  846. progreso=$((progreso + 1))
  847. # } > >(whiptail --gauge "Instalando Moodle..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  848. echo -en " OK.\n" | tee -a $logFile
  849. fi
  850. # PRECAUCION!!!! Hay que habilitar algunos servicios antes de configurarlos
  851. # Por ejemplo: para cambiar la contraseña de root en mysql
  852. # Configuración
  853. # Configuración Apache
  854. # Virtual Hosts
  855. if [ $infoPHPOn = true ];then
  856. echo -en "Configurando 'info.php'..." | tee -a $logFile
  857. instalarPHPInfo
  858. echo -en " OK.\n" | tee -a $logFile
  859. fi
  860. echo -en "Configurando Servidor Web..." | tee -a $logFile
  861. # {
  862. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  863. configurarNginx
  864. progreso=$((progreso + 1))
  865. # } > >(whiptail --gauge "Configurando Servidor Web..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  866. echo -en " OK.\n" | tee -a $logFile
  867. # Configuración Database
  868. # Arrancar Base de Datos, establecer contraseña y configuración segura
  869. if [ $mySQLOn = true ];then
  870. habilitarServicio mysql
  871. echo -en "Configurando Base de Datos MySQL..." | tee -a $logFile
  872. # {
  873. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  874. establecerSQLPasswd
  875. progreso=$((progreso + 1))
  876. # } > >(whiptail --gauge "Configurando Base de Datos MySQL..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  877. echo -en " OK.\n" | tee -a $logFile
  878. fi
  879. if [ $mariaDBOn = true ];then
  880. habilitarServicio mariadb
  881. echo -en "Configurando Base de Datos MariaDB..." | tee -a $logFile
  882. # {
  883. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  884. establecerSQLPasswd
  885. progreso=$((progreso + 1))
  886. # } > >(whiptail --gauge "Configurando Base de Datos MariaDB..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  887. echo -en " OK.\n" | tee -a $logFile
  888. fi
  889. # Configuración PHP
  890. # cgi.fix_pathinfo=0
  891. # Configurar máximo de subida de archivos
  892. if [ $phpOn = true ];then
  893. echo -en "Configurando PHP-7..." | tee -a $logFile
  894. # {
  895. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  896. configurarPHP
  897. progreso=$((progreso + 1))
  898. # } > >(whiptail --gauge "Configurando PHP-7..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  899. echo -en " OK.\n" | tee -a $logFile
  900. fi
  901. # Configuración MediWiki
  902. echo -en "Configurando MediaWiki..." | tee -a $logFile
  903. # {
  904. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  905. sleep 2
  906. progreso=$((progreso + 1))
  907. # } > >(whiptail --gauge "Configurando MediaWiki..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  908. echo -en " OK.\n" | tee -a $logFile
  909. # Configuración Moodle
  910. echo -en "Configurando Moodle..." | tee -a $logFile
  911. # {
  912. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  913. sleep 2
  914. progreso=$((progreso + 1))
  915. # } > >(whiptail --gauge "Configurando Moodle..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  916. echo -en " OK.\n" | tee -a $logFile
  917. # Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
  918. # {
  919. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  920. if [ $apacheOn = true ];then
  921. if [ $debianOS = true ];then
  922. habilitarServicio apache2
  923. elif [ $rhelOS = true ];then
  924. habilitarServicio httpd
  925. fi
  926. elif [ $nginxOn = true ];then
  927. habilitarServicio nginx
  928. if [ $phpOn = true ];then
  929. if [ $debianOS = true ];then
  930. habilitarServicio php7.2-fpm
  931. elif [ $rhelOS = true ];then
  932. habilitarServicio php-fpm
  933. fi
  934. fi
  935. fi
  936. progreso=$((progreso + 1))
  937. # } > >(whiptail --gauge "Arrancando Servicios..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  938. # Añadir reglas del cortafuegos
  939. echo -en "Configurando Cortafuegos..." | tee -a $logFile
  940. # {
  941. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  942. sleep 2
  943. progreso=$((progreso + 1))
  944. # } > >(whiptail --gauge "Configurando Cortafuegos..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  945. echo -en " OK.\n" | tee -a $logFile
  946. # Configuración SSL/TLS
  947. # Generar certificados
  948. # Configurar certificados
  949. echo -en "Configurando SSL/TLS..." | tee -a $logFile
  950. # {
  951. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  952. sleep 2
  953. progreso=$((progreso + 1))
  954. # } > >(whiptail --gauge "Configurando SSL/TLS..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  955. echo -en " OK.\n" | tee -a $logFile
  956. # Configurar actualizaciones
  957. if [ $actualizacionesOn = true ]; then
  958. echo -en "Configurando actualizaciones automáticas..." | tee -a $logFile
  959. # {
  960. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  961. sleep 2
  962. progreso=$((progreso + 1))
  963. # } > >(whiptail --gauge "Configurando actualizaciones automáticas..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  964. echo -en " OK.\n" | tee -a $logFile
  965. fi